/**
*****************************************************************************
**  File		: Driver_Keyboard_Matrix_4x4.h
**
**  Created on	: Feb 12, 2016
**
**  Author		: Kirill
**
**  Abstract    :    .
**  			    .      ,
**  			    ,    (   ).
**
**
**  Functions   :
*****************************************************************************
*/
#ifndef KEYBOARD_MATRIX_H_
#define KEYBOARD_MATRIX_H_
//---------------------------------------------------------
/* Private define  */

/*
 *      		<<!
 * K0 - K3 -  (,  ) - OD ( )
 * K4 - K7 -  (,  ) - PU ( )
 *
 *   ():
 * COL - K7  K6  K5  K4
 * ROW   |   |   |   |
 *  |    |   |   |   |
 * K3 -  1   2   3  stop
 * K2 -  4   5   6   go
 * K1 -  7   8   9  lock
 * K0 - ent  0  esc  pow
 *
 *
 */
/*   -  */
//#define USE_LONGPRESS						//    

#define NUM_COL 			4				//<! -  
#define NUM_ROW 			4				//<! -  

#define KBD_ROW_PORT		GPIOA			//<!     
#define KBD_COL_PORT		GPIOA			//<!     

#define KBD_K0				GPIO_Pin_7		//<!   
#define KBD_K1				GPIO_Pin_6		//<!    
#define KBD_K2				GPIO_Pin_5		//<!
#define KBD_K3				GPIO_Pin_4		//<!
#define KBD_K4				GPIO_Pin_3		//<!
#define KBD_K5				GPIO_Pin_2		//<!
#define KBD_K6				GPIO_Pin_1		//<!
#define KBD_K7				GPIO_Pin_0		//<!

/*  ,   */
#define SEL_ROW_1			KBD_K0<<16 | KBD_K1 | KBD_K2 | KBD_K3
#define SEL_ROW_2			KBD_K0 | KBD_K1<<16 | KBD_K2 | KBD_K3
#define SEL_ROW_3			KBD_K0 | KBD_K1 | KBD_K2<<16 | KBD_K3
#define SEL_ROW_4			KBD_K0 | KBD_K1 | KBD_K2 | KBD_K3<<16
//#define SEL_ROW_5

//-------------------------------
/*       */
#define KEYPRESS_FLAG		0x01			//   
#define KEYLONGPRESS_FLAG	0x02			//    
#define KEYRELEASE_FLAG		0x04			//   
#define ACTION_COMPLETE		0x80			//      

#define KEYHOLD_THRES		50				//<!     ,
											//       ,
											//      

//-------------------------------------------------------
/* Private variables */
uint8_t kbd_keycode;						//     
uint8_t kbd_keyflags;						//     

//-------------------------------------------------------
/* Private function prototypes */
void Initial_Key_Port(void);				//   
void Keyboard_scan (uint8_t *kbd_keycode, uint8_t *kbd_keyflags);	//  
void Key_Actions (uint8_t *kbd_keycode, uint8_t *kbd_keyflags);		//    

#endif /* KEYBOARD_MATRIX_H_ */
